<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__prot" kind="group">
    <compoundname>group_prot</compoundname>
    <title>Prot         (Protection Unit)</title>
    <innergroup refid="group__group__prot__macros">Macros</innergroup>
    <innergroup refid="group__group__prot__functions">Functions</innergroup>
    <innergroup refid="group__group__prot__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__prot__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The Protection Unit driver provides an API to configure the Memory Protection Units (MPU), Shared Memory Protection Units (SMPU), and Peripheral Protection Units (PPU). </para>    </briefdescription>
    <detaileddescription>
<para>These are separate from the ARM Core MPUs and provide additional mechanisms for securing resource accesses. The Protection units address the following concerns in an embedded design:<itemizedlist>
<listitem><para><bold>Security requirements:</bold> This includes the prevention of malicious attacks to access secure memory or peripherals.</para></listitem><listitem><para><bold>Safety requirements:</bold> This includes detection of accidental (non-malicious) SW errors and random HW errors. It is important to enable failure analysis to investigate the root cause of a safety violation.</para></listitem></itemizedlist>
</para><para>The functions and other declarations used in this driver are in cy_prot.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para>
<para><heading level="1">Protection Types</heading></para>
<para>Protection units are hardware configuration structures that control bus accesses to the resources that they protect. By combining these individual configuration structures, a system is built to allow strict restrictions on the capabilities of individual bus masters (e.g. CM0+, CM4, Crypt) and their operating modes. This architecture can then be integrated into the overall security system of the end application. To build this system, 3 main protection unit types are available; MPU, SMPU and PPU. When a resource is accessed (memory/register), it must pass the evaluation performed for each category. These access evaluations are prioritized, where MPU has the highest priority, followed by SMPU, followed by PPU. i.e. if an SMPU and a PPU protect the same resource and if access is denied by the SMPU, then the PPU access evaluation is skipped. This can lead to a denial-of-service scenario and the application should pay special attention in taking ownership of the protection unit configurations.</para>
<para><bold>Memory Protection</bold></para>
<para>Memory access control for a bus master is controlled using an MPU. These are most often used to distinguish user and privileged accesses from a single bus master such as task switching in an OS/kernel. For ARM cores (CM0+, CM4), the core MPUs are used to perform this task. For other non-ARM bus masters such as Crypto, MPU structs are available, which can be used in a similar manner as the ARM core MPUs. These MPUs however must be configured by the ARM cores. Other bus masters that do not have an MPU, such as DMA (DW), inherit the access control attributes of the bus master that configured the channel. Also note that unlike other protection units, MPUs do not support protection context evaluation. MPU structs have a descending priority, where larger index struct has higher priority access evaluation over lower index structs. E.g. MPU_STRUCT15 has higher priority than MPU_STRUCT14 and its access will be evaluated before MPU_STRUCT14. If both target the same memory, then the higher index (MPU_STRUCT15) will be used, and the lower index (MPU_STRUCT14) will be ignored.</para>

<para><bold>Shared Memory Protection</bold></para>
<para>In order to protect a region of memory from all bus masters, an SMPU is used. This protection effectively allows only those with correct bus master access settings to read/write/execute the memory region. This type of protection is used in general memory such as Flash and SRAM. Peripheral registers are best configured using the peripheral protection units instead. SMPU structs have a descending priority, where larger index struct has higher priority access evaluation over lower index structs. E.g. SMPU_STRUCT15 has higher priority than SMPU_STRUCT14 and its access will be evaluated before SMPU_STRUCT14. If both target the same memory, then the higher index (MPU_STRUCT15) will be used, and the lower index (SMPU_STRUCT14) will be ignored.</para>

<para><bold>Peripheral Protection</bold></para>
<para>Peripheral protection is provided by PPUs and allow control of peripheral register accesses by bus masters. Four types of PPUs are available.<itemizedlist>
<listitem><para><bold>Fixed Group (GR) PPUs</bold> are used to protect an entire peripheral MMIO group from invalid bus master accesses. The MMIO grouping information and which resource belongs to which group is device specific and can be obtained from the device technical reference manual (TRM). Group PPUs have the highest priority in the PPU category. Therefore their access evaluations take precedence over the other types of PPUs.</para></listitem><listitem><para><bold>Programmable (PROG) PPUs</bold> are used to protect any peripheral memory region in a device from invalid bus master accesses. It is the most versatile type of peripheral protection unit. Programmable PPUs have the second highest priority and take precedence over Region PPUs and Slave PPUs. Similar to SMPUs, higher index PROG PPUs have higher priority than lower indexes PROG PPUs.</para></listitem><listitem><para><bold>Fixed Region (RG) PPUs</bold> are used to protect an entire peripheral slave instance from invalid bus master accesses. For example, TCPWM0, TCPWM1, SCB0, and SCB1, etc. Region PPUs have the third highest priority and take precedence over Slave PPUs.</para></listitem><listitem><para><bold>Fixed Slave (SL) PPUs</bold> are used to protect specified regions of peripheral instances. For example, individual DW channel structs, SMPU structs, and IPC structs, etc. Slave PPUs have the lowest priority in the PPU category and therefore are evaluated last.</para></listitem></itemizedlist>
</para>


<para><heading level="1">Protection Context</heading></para>
<para>Protection context (PC) attribute is present in all bus masters and is evaluated when accessing memory protected by an SMPU or a PPU. There are no limitations to how the PC values are allocated to the bus masters and this makes it possible for multiple bus masters to essentially share protection context values. The exception to this rule is the PC value 0.</para>
<para><bold>PC=0</bold></para>
<para>Protection context 0 is a hardware controlled protection context update mechanism that allows only a single entry point for transitioning into PC=0 value. This mechanism is only present for the secure CM0+ core and is a fundamental feature in defining a security solution. While all bus masters are configured to PC=0 at device boot, it is up to the security solution to transition these bus masters to PC!=0 values. Once this is done, those bus masters can no longer revert back to PC=0 and can no longer access resources protected at PC=0.</para><para>In order to enter PC=0, the CM0+ core must assign an interrupt vector or an exception handler address to the CPUSS.CM0_PC0_HANDLER register. This allows the hardware to check whether the executing code address matches the value in this register. If they match, the current PC value is saved and the CM0+ bus master automatically transitions to PC=0. It is then up to the executing code to decide if and when it will revert to a PC!=0 value. At that point, the only way to re-transition to PC=0 is through the defined exception/interrupt handler.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Devices with CPUSS ver_2 have a hardware-controlled protection context update mechanism that allows only a single-entry point for transitioning into PC=0, 1, 2, and 3. The interrupt vector or the exception handler address can be assigned to the CPUSS.CM0_PC0_HANDLER, CPUSS.CM0_PC1_HANDLER, CPUSS.CM0_PC2_HANDLER or CPUSS.CM0_PC2_HANDLER register. Also, the control register CPUSS.CM0_PC_CTL of the CM0+ protection context must be set: bit 0 - the valid field for CM0_PC0_HANDLER, bit 1 - the valid field for CM0_PC1_HANDLER, bit 2 - the valid field for CM0_PC2_HANDLER, and bit 3 - the valid field for CM0_PC3_HANDLER.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;The example of using of the single entry point mechanism is shown below. </verbatim><programlisting><codeline><highlight class="comment">/*<sp />The<sp />code<sp />below<sp />demonstrates<sp />the<sp />protection<sp />context<sp />update<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />mechanism<sp />that<sp />allows<sp />a<sp />single<sp />entry<sp />point<sp />for<sp />transitioning<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />from<sp />PC<sp />=<sp />1<sp />into<sp />PC=0<sp />value.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Note:<sp />"cy_ipc_drv.h",<sp />"cy_prot.h"<sp />and<sp />"cy_sysint.h"<sp />should<sp />be<sp />included.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />IPC_INTR_NR<sp />10u</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />pc;<sp /></highlight><highlight class="comment">/*<sp />The<sp />active<sp />protection<sp />context<sp />of<sp />a<sp />master.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />isrTriggered<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;<sp /></highlight><highlight class="comment">/*<sp />The<sp />ISR<sp />flag.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />IPC<sp />ISR<sp />handler.<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />isrPC0(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />protection<sp />context<sp />is<sp />0<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />isrTriggered<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;<sp /></highlight><highlight class="comment">/*<sp />Set<sp />flag<sp />that<sp />ISR<sp />is<sp />triggered.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__functions_1gaa3dbb5de3a3b0336daa2758e72dded45">Cy_IPC_Drv_ClearInterrupt</ref>(<ref kindref="member" refid="group__group__ipc__functions_1gaea293f27dc3d6d69eb40ef2d8f5c8d2b">Cy_IPC_Drv_GetIntrBaseAddr</ref>(IPC_INTR_NR),<sp />0u,<sp />1u);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />main(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />__enable_irq();<sp /></highlight><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />CM4.<sp />CY_CORTEX_M4_APPL_ADDR<sp />must<sp />be<sp />updated<sp />if<sp />CM4<sp />memory<sp />layout<sp />is<sp />changed.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4</ref>(<ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref>);<sp /></highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Assign<sp />the<sp />isrPC0<sp />interrupt<sp />vector<sp />to<sp />the<sp />CM0_PC0_HANDLER<sp />register.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CPUSS-&gt;CM0_PC0_HANDLER<sp />=<sp />(uint32_t)&amp;isrPC0;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />IPC<sp />interrupt<sp />handler.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__functions_1ga6e910b181ed0ef66a0fa9a2cc9afa105">Cy_IPC_Drv_SetInterruptMask</ref>(<ref kindref="member" refid="group__group__ipc__functions_1gaea293f27dc3d6d69eb40ef2d8f5c8d2b">Cy_IPC_Drv_GetIntrBaseAddr</ref>(IPC_INTR_NR),<sp />0u,<sp />1u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />intr<sp />=<sp />{</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp />=<sp />NvicMux5_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.cm0pSrc<sp />=<sp />cpuss_interrupts_ipc_10_IRQn,</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />cpuss_interrupts_ipc_10_IRQn,</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />(CY_CPU_CORTEX_M0P)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />2u</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;intr,<sp />isrPC0);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ(intr.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />bus<sp />master<sp />to<sp />allow<sp />setting<sp />PC<sp />to<sp />PC=1<sp />and<sp />PC=2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__prot__functions__busmaster_1ga4b69f79e24b30f22a706e973b05dd079">Cy_Prot_ConfigBusMaster</ref>(CPUSS_MS_ID_CM0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><ref kindref="member" refid="group__group__prot__enums_1gga4486bc74d6e98ad99c1ce4d532e48d0fabf25e25bbce833636da932ce78e453e8">CY_PROT_PCMASK1</ref><sp />|<sp /><ref kindref="member" refid="group__group__prot__enums_1gga4486bc74d6e98ad99c1ce4d532e48d0fa0b17d740a164ae90f06a4ab2f17d79d0">CY_PROT_PCMASK2</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />CM0+<sp />PC<sp />value<sp />to<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__prot__enums_1gga13ede85383a4afaf5ed3a14b470e38bda462f07fcb31ed8a07dd273af4290691d">CY_PROT_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__prot__functions__busmaster_1ga2d3a54039578a9fae98f6c7b4c4cff41">Cy_Prot_SetActivePC</ref>(CPUSS_MS_ID_CM0,<sp /><ref kindref="member" refid="group__group__prot__enums_1gga4467b93f3da4304e584726b975d3fabaa10dc15f2738ba076ded84cb7b9eac7fa">CY_PROT_PC1</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />pc<sp />=<sp /><ref kindref="member" refid="group__group__prot__functions__busmaster_1gac6af4217bc8ac5517edb39ebe11e91ec">Cy_Prot_GetActivePC</ref>(CPUSS_MS_ID_CM0);<sp /></highlight><highlight class="comment">/*<sp />pc<sp />should<sp />equal<sp />to<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__functions_1ga4223d653355f0cd7890b57ab1e8d1ff6">Cy_IPC_Drv_SetInterrupt</ref>(<ref kindref="member" refid="group__group__ipc__functions_1gaea293f27dc3d6d69eb40ef2d8f5c8d2b">Cy_IPC_Drv_GetIntrBaseAddr</ref>(IPC_INTR_NR),<sp />0u,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />Trigger<sp />the<sp />ISR<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(!isrTriggered)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />until<sp />isrPC0<sp />ISR<sp />entered.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />pc<sp />=<sp /><ref kindref="member" refid="group__group__prot__functions__busmaster_1gac6af4217bc8ac5517edb39ebe11e91ec">Cy_Prot_GetActivePC</ref>(CPUSS_MS_ID_CM0);<sp /></highlight><highlight class="comment">/*<sp />pc<sp />should<sp />equal<sp />to<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>


<para><heading level="1">Access Evaluation</heading></para>
<para>Each protection unit is capable of evaluating several access types. These can be used to build a system of logical evaluations for different kinds of bus master modes of operations. These access types can be divided into three broad access categories.</para><para><itemizedlist>
<listitem><para><bold>User/Privileged access:</bold> The ARM convention of user mode versus privileged mode is applied in the protection units. For ARM cores, switching between user and privileged modes is handled by updating its Control register or by exception entries. Other bus masters such as Crypto have their own user/privileged settings bit in the bus master control register. This is then controlled by the ARM cores. Bus masters that do not have user/privileged access controls, such as DMA, inherit their attributes from the bus master that configured it. The user/privileged distinction is used mainly in the MPUs for single bus master accesses but they can also be used in all other protection units.</para></listitem><listitem><para><bold>Secure/Non-secure access:</bold> The secure/non-secure attribute is another identifier to distinguish between two separate modes of operations. Much like the user/privileged access, the secure/non-secure mode flag is present in the bus master control register. The ARM core does not have this attribute in its control register and must use the bus master control register instead. Bus masters that inherit their attributes, such as DMA, inherit the secure/non-secure attribute. The primary use-case for this access evaluation is to define a region to be secure or non-secure using an SMPU or a PPU. A bus master with a secure attribute can access both secure and non-secure regions, whereas a bus master with non-secure attribute can only access non-secure regions.</para></listitem><listitem><para><bold>Protection Context access:</bold> Protection Context is an attribute that serves two purposes; To enter the hardware controlled secure PC=0 mode of operation from non-secure modes and to provide finer granularity to the bus master access definitions. It is used in SMPU and PPU configuration to control which bus master protection context can access the resources that they protect.</para></listitem></itemizedlist>
</para>

<para><heading level="1">Protection Structure</heading></para>
<para>Each protection unit is comprised of a master struct and a slave struct pair. The exception to this rule is MPU structs, which only have the slave struct equivalent. The protection units apply their access evaluations in a decreasing index order. For example, if SMPU1 and SMPU2 both protect a specific memory region, the the higher index (SMPU2) will be evaluated first. In a secure system, the higher index protection structs would then provide the high level of security and the lower indexes would provide the lower level of security. Refer to the <ref kindref="member" refid="group__group__prot_1group_prot_protection_type">Protection Types</ref> section for more information.</para>
<para><bold>Slave Struct</bold></para>
<para>The slave struct is used to configure the protection settings for the resource of interest (memory/registers). Depending on the type of protection unit, the available attributes differ. However all Slave protection units have the following general format.</para>
<para><bold>Slave Struct Address Definition</bold></para>
<para><itemizedlist>
<listitem><para>Address: For MPU, SMPU and PROG PPU, the address field is used to define the base memory region to apply the protection. This field has a dependency on the region size, which dictates the alignment of the protection unit. E.g. if the region size is 64KB, the address field is aligned to 64KB. Hence the lowest bits [15:0] are ignored. For instance, if the address is defined at 0x0800FFFF, the protection unit would apply its protection settings from 0x08000000. Thus alignment must be checked before defining the protection address. The address field for other PPUs are not used, as they are bound to their respective peripheral memory locations.</para></listitem><listitem><para>Region Size: For MPU, SMPU and PROG PPU, the region size is used to define the memory block size to apply the protection settings, starting from the defined base address. It is also used to define the 8 sub-regions for the chosen memory block. E.g. If the region size is 64KB, each subregion would be 8KB. This information can then be used to disable the protection settings for select subregions, which gives finer granularity to the memory regions. PPUs do not have region size definitions as they are bound to their respective peripheral memory locations.</para></listitem><listitem><para>Subregions: The memory block defined by the address and region size fields is divided into 8 (0 to 7) equally spaced subregions. The protection settings of the protection unit can be disabled for these subregions. E.g. for a given 64KB of memory block starting from address 0x08000000, disabling subregion 0 would result in the protection settings not affecting the memory located between 0x08000000 to 0x08001FFF. PPUs do not have subregion definitions as they are bound to their respective peripheral memory locations.</para></listitem></itemizedlist>
</para>

<para><bold>Slave Struct Attribute Definition</bold></para>
<para><itemizedlist>
<listitem><para>User Permission: Protection units can control the access restrictions of the read (R), write (W) and execute (X) (subject to their availability depending on the type of protection unit) operations on the memory block when the bus master is operating in user mode. PPU structs do not provide execute attributes.</para></listitem><listitem><para>Privileged Permission: Similar to the user permission, protection units can control the access restrictions of the read (R), write (W) and execute (X) (subject to their availability depending on the type of protection unit) operations on the memory block when the bus master is operating in privileged mode. PPU structs do not provide execute attributes.</para></listitem><listitem><para>Secure/Non-secure: Applies the secure/non-secure protection settings to the defined memory region. Secure protection allows only bus masters that access the memory with secure attribute. Non-secure protection allows bus masters that have either secure or non-secure attributes.</para></listitem><listitem><para>PC match: This attribute allows the protection unit to either apply the 3 access evaluations (user/privileged, secure/non-secure, protection context) or to only provide an address range match. This is useful when multiple protection units protect an overlapping memory region and it's desirable to only have access evaluations applied from only one of these protection units. For example, SMPU1 protects memory A and SMPU2 protects memory B. There exists a region where A and B intersect and this is accessed by a bus master. Both SMPU1 and SMPU2 are configured to operate in "match" mode. In this scenario, the access evaluation will only be applied by the higher index protection unit (i.e. SMPU2) and the access attributes of SMPU1 will be ignored. If the bus master then tries to access a memory region A (that does not intersect with B), the access evaluation from SMPU1 will be used. Note that the PC match functionality is only available in SMPUs.</para></listitem><listitem><para>PC mask: Defines the allowed protection context values that can access the protected memory. The bus master attribute must be operating in one of the protection context values allowed by the protection unit. E.g. If SMPU1 is configured to allow only PC=1 and PC=5, a bus master (such as CM4) must be operating at PC=1 or PC=5 when accessing the protected memory region.</para></listitem></itemizedlist>
</para>


<para><bold>Master Struct</bold></para>
<para>The master struct protects its slave struct in the protection unit. This architecture makes possible for the slave configuration to be protected from reconfiguration by an unauthorized bus master. The configuration attributes and the format are similar to that of the slave structs.</para>
<para><bold>Master Struct Address Definition</bold></para>
<para><itemizedlist>
<listitem><para>Address: The address definition for master struct is fixed to the slave struct that it protects.</para></listitem><listitem><para>Region Size: The region size is fixed to 256B region.</para></listitem><listitem><para>Subregion: This value is fixed to only enable the first 64B subregions, which applies the protection settings to the entire protection unit.</para></listitem></itemizedlist>
</para>

<para><bold>Master Struct Attribute Definition</bold></para>
<para><itemizedlist>
<listitem><para>User Permission: Only the write (W) access attribute is allowed for master structs, which controls whether a bus master operating in user mode has the write access.</para></listitem><listitem><para>Privileged Permission: Only the write (W) access attribute is allowed for master structs, which controls whether a bus master operating in privileged mode has the write access.</para></listitem><listitem><para>Secure/Non-Secure: Same behavior as slave struct.</para></listitem><listitem><para>PC match: Same behavior as slave struct.</para></listitem><listitem><para>PC mask: Same behavior as slave struct.</para></listitem></itemizedlist>
</para>



<para><heading level="1">Driver Usage</heading></para>
<para>Setting up and using protection units can be summed up in four stages:</para><para><itemizedlist>
<listitem><para>Configure the bus master attributes. This defines the capabilities of the bus master when trying to access the protected resources.</para></listitem><listitem><para>Configure the slave struct of a given protection unit. This defines the protection attributes to be applied to the bus master accessing the protected resource and also defines the size and location of the memory block to protect.</para></listitem><listitem><para>Configure the master struct of the protection unit. This defines the attributes to be checked against the bus master that is trying to reconfigure the slave struct.</para></listitem><listitem><para>Set the active PC value of the bus master and place it in the correct mode of operation (user/privileged, secure/non-secure). Then access the protected memory.</para></listitem></itemizedlist>
</para><para>For example, by configuring the CM0+ bus master configuration to allow only protection contexts 2 and 3, the bus master will be able to set its protection context only to 2 or 3. During runtime, the CM0+ core can set its protection context to 2 by calling <ref kindref="member" refid="group__group__prot__functions__busmaster_1ga2d3a54039578a9fae98f6c7b4c4cff41">Cy_Prot_SetActivePC()</ref> and access all regions of protected memory that allow PC=2. A fault will be triggered if a resource is protected with different protection settings.</para><para>Note that each protection unit is distinguished by its type (e.g. <ref kindref="compound" refid="struct_p_r_o_t___m_p_u___m_p_u___s_t_r_u_c_t___type">PROT_MPU_MPU_STRUCT_Type</ref>). The list of supported protection units can be obtained from the device definition header file. Choose a protection unit of interest, and call its corresponding Cy_Prot_Config&lt;X&gt;Struct() function with its software protection unit configuration structure populated. Then enable the protection unit by calling the Cy_Prot_Enable&lt;X&gt;Struct() function.</para><para>Note that the bus master ID (en_prot_master_t) is defined in the device config header file.</para>

<para><heading level="1">Configuration Considerations</heading></para>
<para>When a resource (memory/register) is accessed, it must pass evaluation of all three protection unit categories in the following order: MPU-&gt;SMPU-&gt;PPU. The application should ensure that a denial-of-service attack cannot be made on the PPU by the SMPU. For this reason, it is recommended that the application's security policy limit the ability for the non-secure client from configuring the SMPUs.</para><para>Within each category, the priority hierarchy must be carefully considered to ensure that a higher priority protection unit cannot be configured to override the security configuration of a lower index protection unit. Therefore if a lower index protection unit is configured, relevant higher priority indexes should be configured (or protected from unwanted reconfiguration). E.g. If a PPU_SL is configured, PPU_RG and PPU_GR that overlaps with the protected registers should also be configured. SImilar to SMPUs, it is recommended that the configuration of PPU_PROG be limited. Otherwise they can be used to override the protection settings of PPU_RG and PPU_SL structs.</para><para>All bus masters are set to PC=0 value at device reset and therefore have full access to all resources. It is up to the security solution to implement what privileges each bus master has. Once transitioned to a PC!=0 value, only the CM0+ core is capable of re-entering the PC=0 via the user-defined exception entry in the CPUSS.CM0_PC0_HANDLER register.</para><para><itemizedlist>
<listitem><para>SMPU 15 and 14 are configured and enabled to only allow PC=0 accesses at device boot.</para></listitem><listitem><para>PROG PPU 15, 14, 13 and 12 are configured to only allow PC=0 accesses at device boot.</para></listitem><listitem><para>GR PPU 0 and 2 are configured to only allow PC=0 accesses at device boot.</para></listitem></itemizedlist>
</para>

<para><heading level="1">More Information</heading></para>
<para>Refer to Technical Reference Manual (TRM) and the device datasheet.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The Prot driver has the following specific deviations:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This piece of code is written for DW_V2_Type only and it will be never executed for DW_V1_Type (which is a default build option for &lt;a href="struct_d_w___type.html#"&gt;DW_Type&lt;/a&gt;).  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;19.13 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The # and ## operators should not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The ## preprocessor operator is used in macros to form the field mask.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Clarified the description of the next API functions: &lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1gaa20aec5caa83d665c5a2afe241b6c69e"&gt;Cy_Prot_ConfigPpuProgMasterAtt&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1ga7941e969542970aedcb056f554b5383b"&gt;Cy_Prot_ConfigPpuProgSlaveAtt&lt;/a&gt;, &lt;a href="group__group__prot__functions__ppu__fixed__v2.html#group__group__prot__functions__ppu__fixed__v2_1gacc7dadd726bd53886aedfbfa1014ae9e"&gt;Cy_Prot_ConfigPpuFixedMasterAtt&lt;/a&gt;, &lt;a href="group__group__prot__functions__ppu__fixed__v2.html#group__group__prot__functions__ppu__fixed__v2_1ga6112f6eba93e5db763e8dc571a91740a"&gt;Cy_Prot_ConfigPpuFixedSlaveAtt&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;API enhancement based on usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Snippet updated. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Old snippet outdated.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect in &lt;a href="group__group__prot__functions__ppu__prog.html#group__group__prot__functions__ppu__prog_1gaea671baa8df5f37922e7325a291e250c"&gt;Cy_Prot_GetPpuProgStruct()&lt;/a&gt; function due to faulty defines is fixed. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added functions for CPUSS ver_2:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1gaa20aec5caa83d665c5a2afe241b6c69e"&gt;Cy_Prot_ConfigPpuProgMasterAtt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1ga37f73e968bc327a33ae55eab02c315ac"&gt;Cy_Prot_ConfigPpuProgSlaveAddr()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1ga7941e969542970aedcb056f554b5383b"&gt;Cy_Prot_ConfigPpuProgSlaveAtt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1ga93cd67a67fecfb39b3df272b9f64a780"&gt;Cy_Prot_EnablePpuProgSlaveRegion()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__prog__v2.html#group__group__prot__functions__ppu__prog__v2_1gacd5db7ab07edb2943e6f0c2486c6c6d0"&gt;Cy_Prot_DisablePpuProgSlaveRegion()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__fixed__v2.html#group__group__prot__functions__ppu__fixed__v2_1gacc7dadd726bd53886aedfbfa1014ae9e"&gt;Cy_Prot_ConfigPpuFixedMasterAtt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__prot__functions__ppu__fixed__v2.html#group__group__prot__functions__ppu__fixed__v2_1ga6112f6eba93e5db763e8dc571a91740a"&gt;Cy_Prot_ConfigPpuFixedSlaveAtt()&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support for CPUSS ver_2.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added input parameter validation to the API functions.&lt;br /&gt; cy_en_prot_pcmask_t, cy_en_prot_subreg_t and cy_en_prot_pc_t types are set to typedef enum &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved debugging capability  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Expanded documentation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>